/* $Id: xgauge.h,v 1.1 1998/07/26 05:45:53 glgay Exp $ */
/*
 Copyright (C) 1996 Peter Williams
 
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License 
 version 2 as published by the Free Software Foundation.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA.
*/

#if !defined(_XGAUGE_H_)
#define _XGAUGE_H_

#include <Xarm/AppContext.h>
#include <Xarm/Gauge.h>
#include <Xarm/Scale.h>
#include <Xarm/RowColumn.h>
#include <Xarm/Form.h>
#include <Xarm/XarmArg.h>

char *basename(char *);

class GaugeDemo: public AppContext
{
 private:
   void  onExit(Widget,XtPointer,XtPointer);
   void  onInc(Widget,XtPointer,XtPointer);
   void  exit(Widget,XtPointer,XtPointer);
   Gauge *meter1;
   Gauge *meter2;
   Scale *scale; 
   Pixmap pixmap;
 public:
   GaugeDemo(char *app_class, int &argc_in_out, char **argv_in_out);
};

#define miniweave_tile_width 32
#define miniweave_tile_height 32
static char miniweave_tile_bits[] = {
   0x39, 0x39, 0x39, 0x39, 0x70, 0x70, 0x70, 0x70, 0xe0, 0xe0, 0xe0, 0xe0,
   0xc9, 0xc9, 0xc9, 0xc9, 0x9c, 0x9c, 0x9c, 0x9c, 0x0e, 0x0e, 0x0e, 0x0e,
   0x07, 0x07, 0x07, 0x07, 0x93, 0x93, 0x93, 0x93, 0x39, 0x39, 0x39, 0x39,
   0x70, 0x70, 0x70, 0x70, 0xe0, 0xe0, 0xe0, 0xe0, 0xc9, 0xc9, 0xc9, 0xc9,
   0x9c, 0x9c, 0x9c, 0x9c, 0x0e, 0x0e, 0x0e, 0x0e, 0x07, 0x07, 0x07, 0x07,
   0x93, 0x93, 0x93, 0x93, 0x39, 0x39, 0x39, 0x39, 0x70, 0x70, 0x70, 0x70,
   0xe0, 0xe0, 0xe0, 0xe0, 0xc9, 0xc9, 0xc9, 0xc9, 0x9c, 0x9c, 0x9c, 0x9c,
   0x0e, 0x0e, 0x0e, 0x0e, 0x07, 0x07, 0x07, 0x07, 0x93, 0x93, 0x93, 0x93,
   0x39, 0x39, 0x39, 0x39, 0x70, 0x70, 0x70, 0x70, 0xe0, 0xe0, 0xe0, 0xe0,
   0xc9, 0xc9, 0xc9, 0xc9, 0x9c, 0x9c, 0x9c, 0x9c, 0x0e, 0x0e, 0x0e, 0x0e,
   0x07, 0x07, 0x07, 0x07, 0x93, 0x93, 0x93, 0x13};

#endif 

